<?php
/* Copyright (C) 2014 Oscim 	<support@oscim.fr>
 * Copyright (C) 2015 Oscss-Shop Team <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
 
dol_include_once('/dolmessage/class/connector/dolimap.class.php');


Class dmadvancedconfig
	extends dolimap{
	
		/**
      @var bool checkmode
     */
    public $checkmode = false;
    
    /**
     */
    public function __construct($db, $user, $checkmode=false) {
			$this->db = $db;
			$this->user = $user;
			$this->checkmode = $checkmode; 
			
			if(!$this->checkmode){
				imap_timeout(IMAP_OPENTIMEOUT, 5);
				imap_timeout(IMAP_READTIMEOUT, 15);
				imap_timeout(IMAP_WRITETIMEOUT, 5);
				imap_timeout(IMAP_CLOSETIMEOUT, 5);
			}
			else{
				imap_timeout(IMAP_OPENTIMEOUT, 1);
				imap_timeout(IMAP_READTIMEOUT, 3);
				imap_timeout(IMAP_WRITETIMEOUT, 1);
				imap_timeout(IMAP_CLOSETIMEOUT, 1);
			}
    }
    
    /**
      @brief Open Connection
      @param string
     */
    public function Open($folder = '') {

				$path = $this->CleanFolder($folder); 
				
        $this->mbox = @imap_open($this->user->imap_connector_url . $this->CleanFolder($folder), $this->user->imap_login, $this->user->imap_password);

        if($this->mbox === false) {
					$this->listerror[]= array(
							'text'=>'NoSuccessOpenedMailbox'
							,	'param'=>array(
										'url'=> $this->user->imap_connector_url
									, 'folder'=> $path
									, 'login'=> $this->user->imap_login
									, 'password'=> strlen($this->user->imap_password)." caracters"
							)
						);
// 						
					if($this->checkmode) {
						// test no path 
						$this->mbox = @imap_open ($this->user->imap_connector_url,$this->user->imap_login, $this->user->imap_password);
						
						 if($this->mbox != false) 
								$this->listerror[]= array(
							'text'=>'ErrorInFolder'
								,	'param'=>array(
											'url'=> $this->user->imap_connector_url
										, 'folder'=> ''
										, 'login'=> $this->user->imap_login
										, 'password'=> strlen($this->user->imap_password)." caracters"
								)
							);
						else {

								// noo SSL 
								$this->mbox = @imap_open ('{'.$this->user->imap_host.':'.$this->user->imap_port.'}',$this->user->imap_login, $this->user->imap_password);
								if($this->mbox != false) {
										$this->listerror[]= array(
									'text'=>'ServerImapNoSupportSsl'
										,	'param'=>array(
													'url'=> '{'.$this->user->imap_host.':'.$this->user->imap_port.'/}'
												, 'folder'=> ''
												, 'login'=> $this->user->imap_login
												, 'password'=> strlen($this->user->imap_password)." caracters"
										)
										,	'forceconfig'=>array(
												'imap_ssl'=>0
											, 'imap_ssl_novalidate_cert'=>0
										)
									);

								}

								$this->PositionAllCertificats(  ); 
	
						}

							
							
						// test pop3
						if($this->mbox === false){
							$this->mbox = @imap_open ('{'.$this->user->imap_host.':'.$this->user->imap_port.'/pop3/ssl/novalidate-cert}',$this->user->imap_login, $this->user->imap_password);
							if($this->mbox != false) 
									$this->listerror[]= array(
								'text'=>'ServerSupportPop3BuNoImap'
									,	'param'=>array(
												'url'=> '{'.$this->user->imap_host.':'.$this->user->imap_port.'/pop3/ssl/novalidate-cert}'
											, 'folder'=> ''
											, 'login'=> $this->user->imap_login
											, 'password'=> strlen($this->user->imap_password)." caracters"
									)
								);
							}
// 						  var_dump( imap_alerts( $this->mbox)); 
					}
			}

        return $this->mbox ; 
    }
    
  /**
		@fn PositionAllCertificats()
  */
	public function PositionAllCertificats( ){
		// chech position of all certificat 
		
			$this->mbox = @imap_open ('{'.$this->user->imap_host.':'.$this->user->imap_port.'/ssl}',$this->user->imap_login, $this->user->imap_password);
			if($this->mbox != false) 
					$this->listerror[]= array(
				'text'=>'ServerImapNoSupportAllCertificat'
					,	'param'=>array(
								'url'=> '{'.$this->user->imap_host.':'.$this->user->imap_port.'/}'
							, 'folder'=> ''
							, 'login'=> $this->user->imap_login
							, 'password'=> strlen($this->user->imap_password)." caracters"
					)
					,	'forceconfig'=>array(
							'imap_ssl'=>1
						, 'imap_ssl_novalidate_cert'=>0
					)
				);

		// test support no certificat

			$this->mbox = @imap_open ('{'.$this->user->imap_host.':'.$this->user->imap_port.'/ssl/novalidate-cert}',$this->user->imap_login, $this->user->imap_password);
			
// 					var_dump($this->mbox ); 
			if($this->mbox != false) 
					$this->listerror[]= array(
				'text'=>'ServerImapRequireAllCertificat'
					,	'param'=>array(
								'url'=> '{'.$this->user->imap_host.':'.$this->user->imap_port.'/}'
							, 'folder'=> ''
							, 'login'=> $this->user->imap_login
							, 'password'=> strlen($this->user->imap_password)." caracters"
					)
					,	'forceconfig'=>array(
						'imap_ssl'=>1
						, 'imap_ssl_novalidate_cert'=>1
					)
				);

	}
	
	public function FixedConfigUser($userid, $boxid, $forceconfig=array()){
		$db = $this->db;
		$Usermail = new Usermailconfig($db);

		$Usermail->fetch_from_user($userid, $boxid);

		$Usermail->imap_ssl = $forceconfig['imap_ssl'];
		$Usermail->imap_ssl_novalidate_cert = $forceconfig['imap_ssl'];

		if ($Usermail->id > 0) {
				$res = $Usermail->update($user);
		}
// exit; 
		return 1; 
// 		if ($res < 0) {
// 				$db->rollback();
// 		} else {
// 				$db->commit();
// 		}
// 		}
	}
}